CUI_CONFIG_SHOWN = false;

CUI_START_DELAY = 4;

-- saved variables
CleanUICommonData = {}

CleanUIData = {}

CleanUIData.VERSION = nil;

CleanUIData.EQUIPPED_SETNAME = nil;

CleanUIData.SCREENSHOT = 1;
CleanUIData.CHANGE_CHARACTERFRAME = 1;

CleanUIData.BORDER_STYLE = 1;
CleanUIData.CUI_FRAME_BACKGROUND = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-background";
CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border";
CleanUIData.AUTO_CHANGE_BORDER_STYLE = 1;

CleanUIData.STATUSBAR_STYLE = 1;
CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\StatusBar";
CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\StatusBarVertical";

CleanUIData.CHANGE_ACTIONBARS = 1;
CleanUIData.ACTIONBARS_SHOWMACRONAMES = 0;
CleanUIData.ACTIONBARS_SHOWSTATUS = 1;
CleanUIData.ACTIONBARS_SHOWSTATUSTEXT = 1;
CleanUIData.ACTIONBARS_STATUSPOSITION = 1;
CleanUIData.ACTIONBARS_STATUSWIDTH = 60;
CleanUIData.BUTTONFACADE_ACTIONBUTTONS = 1;

CleanUIData.ACTIONBARS_DEBUFFS = 1;
CleanUIData.ACTIONBARS_DEBUFFS_R = 1;
CleanUIData.ACTIONBARS_DEBUFFS_G = 0;
CleanUIData.ACTIONBARS_DEBUFFS_B = 0;
CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = 2;
CleanUIData.BUTTONFACADE_BUFFS = 1;
CleanUIData.BIGGER_DEBUFFS = 1;

CleanUIData.VEHICLEBAR_STYLE = 2;

CleanUIData.CHANGE_BAGS = 1;
CleanUIData.USE_BIGBAG = 0;
CleanUIData.BAGS_COLORIZE_ITEMS = 1;
CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = 1;
CleanUIData.BAGS_MOVEBAGBUTTONS = 1;
CleanUIData.BAGS_SHOWBACKBACKBUTTON = 0;
CleanUIData.BAGS_AUTOREPAIR = 1;
CleanUIData.BAGS_AUTOSELLGRAY = 1;
CleanUIData.BAGPACK_MINIMAP_POS = 45;

CleanUIData.CHANGE_CASTINGBARS = 1;
CleanUIData.CASTINGBARS_SHOWPETBAR = 1;
CleanUIData.CASTINGBARS_ALPHA = 1;
CleanUIData.CASTINGBARS_WIDTH = 300;
CleanUIData.CASTINGBARS_PLAYERHEIGHT = 24;
CleanUIData.CASTINGBARS_IMAGESIZE = 24;
CleanUIData.CASTINGBARS_PETHEIGHT = 16;
CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = 1;
CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = 2;
CleanUIData.CASTINGBARS_LATENCY = 1;

CleanUIData.CHANGE_MINIMAP = 1;
CleanUIData.MAP_SHOWQUESTLEVEL = 1;
CleanUIData.MAP_SHOWSHIPROUTES = 1;

CleanUIData.CHANGE_UNITFRAMES = 1;
CleanUIData.CHANGE_BOSSFRAMES = 1;
CleanUIData.SHOW_DPS = 1;
CleanUIData.SHOW_DPSINFO = 0;
CleanUIData.MERGEPETDPSDATA = 0;
CleanUIData.PORTRAIT_STYLE = 1;
CleanUIData.UNITFRAME_POSITIONS = 1;

CleanUIData.SHOW_XPFRAME = 0;
CleanUIData.SHOW_ORIG_XPBAR = 1;
CleanUIData.XPFRAME_WIDTH = 210;
CleanUIData.XPBAR_HEIGHT = 13;
CleanUIData.XPFRAME_X_XMAX = 1;
CleanUIData.XPFRAME_PERCENT = 1;
CleanUIData.XPFRAME_MAXLEVEL = 0;
CleanUIData.XPFRAME_UNKNOWN = 0;

CleanUIData.SHOW_THREATFRAME = 0;
CleanUIData.THREATFRAME_RAWPCT = 1;
CleanUIData.THREATFRAME_ALPHA = 1;

CleanUIData.CHANGE_CHAT = 1;
CleanUIData.DISABLE_ALTARROWKEYMODE = 1;
CleanUIData.SHOW_CHAT_ACTIONBAR = 1;
CleanUIData.SHOW_CHAT_EMOTICONS = 1;

CleanUIData.CHANGE_RAID = 1;
    
CleanUIData.TOOLTIPS_HIDEINCOMBAT = 0;
CleanUIData.TOOLTIPS_POSITION = 1;

CleanUIData.CHANGE_NAMEPLATES = 1;
CleanUIData.NAMEPLATES_PERCENT = 1;
CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = 1;
CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = 1;

CleanUIData.SHOW_DATABROKER = 1;
CleanUIData.DATABROKER_COUNTROWS = 2;

CleanUIData.DataBroker_Disabled = {};

CleanUIData.unitFramePositions = {};
CleanUIData.unitFramePositions["PlayerFrame"] = nil;
CleanUIData.unitFramePositions["TargetFrame"] = nil;
CleanUIData.unitFramePositions["FocusFrame"] = nil;
CleanUIData.unitFramePositions["PartyMemberFrame1"] = nil;
CleanUIData.unitFramePositions["PartyMemberFrame2"] = nil;
CleanUIData.unitFramePositions["PartyMemberFrame3"] = nil;
CleanUIData.unitFramePositions["PartyMemberFrame4"] = nil;

local BORDER_STYLE = {
	"default",
	"white",
	"black",
	"gray",
	"yellow",
	"red",
	"green",
	"blue",
	"dark yellow",
	"dark red",
	"dark green",
	"dark blue",
}

local STATUSBAR_STYLE = {
	"default",
	"Aluminium",
	"Bantobar",
	"Charcoal",
	"Flat",
	"Frost",
	"Glaze",
	"Healbot",
	"LiteStep",
	"Minimalist",
	"Otravi",
	"Perl",
	"Rocks",
	"Runes",
	"Smooth",
	"Smudge",
	"Striped",
	"SWS",
	"Xeon",
	"Xus",
}

local VEHICLEBAR_STYLE = {
    CONFIG_VEHICLEBAR_STYLE1,
    CONFIG_VEHICLEBAR_STYLE2,
    CONFIG_VEHICLEBAR_STYLE3,
    CONFIG_VEHICLEBAR_STYLE4,
}

local PORTRAIT_TYPE = {
	PORTRAIT_TYPE_3D,
	PORTRAIT_TYPE_CLASSITEM,
}

local UNITFRAME_POSITION_TYPE = {
	CONFIG_DEFAULT_UNITFRAME_POSITIONS,
	CONFIG_BATTLE_UNITFRAME_POSITIONS,
}

local TOOLTIPS_POSITION = {
	CONFIG_TOOLTIP_POSITION_STANDARD,
	CONFIG_TOOLTIP_POSITION_MOUSEPOSITION,
	CONFIG_TOOLTIP_POSITION_TOP,
}


-- functions

function cui_debug(value, name)
    if (name) then
 	    DEFAULT_CHAT_FRAME:AddMessage("debug "..name..": "..(value or "nil"), 1.0, 1.0, 1.0, 1, 10);
    else
 	    DEFAULT_CHAT_FRAME:AddMessage("debug: "..(value or "nil"), 1.0, 1.0, 1.0, 1, 10);
    end
end

function CleanUIConfig_HookEvents()
    hooksecurefunc(InterfaceOptionsFrame, "Show", CleanUIConfig_InterfaceOptionsFrame_Show);
    hooksecurefunc(InterfaceOptionsFrame, "Hide", CleanUIConfig_InterfaceOptionsFrame_Hide);
end

function CleanUIConfig_SaveNameChanged()   
    CleanUIConfig_CheckSave();    
end

function CleanUIConfig_CheckSave()   
    local name = _G["CUIConfig_SaveName"]:GetText();
    
    if (not name or name == "") then
        _G["CUIConfig_Save"]:Disable();
    else
        _G["CUIConfig_Save"]:Enable();
    end
end

function CleanUIConfig_Save()
    local name = _G["CUIConfig_SaveName"]:GetText();
    if (name and name ~= "") then
        CleanUICommonData[name] = CleanUIData;
        UIDropDownMenu_Initialize(_G["CUIConfig_LoadName"], CleanUIConfig_LoadName_Initialize);
        PlaySound("igInventoryOepn");
    end
end

function CleanUIConfig_LoadName_Initialize()
	    
	for name, data in pairs(CleanUICommonData) do 
	    local info = UIDropDownMenu_CreateInfo();
        info.text = name;
        info.value = data;
        info.func = function()
                CleanUIConfig_LoadName_Select(name);
            end
        UIDropDownMenu_AddButton(info);
	end
end

function CleanUIConfig_LoadName_Select(name)   
	UIDropDownMenu_SetText(_G["CUIConfig_LoadName"], name);
end

function CleanUIConfig_Load()   
    local name = UIDropDownMenu_GetText(_G["CUIConfig_LoadName"]);
    
    if (name) then
        CleanUIData = CleanUICommonData[name];    
        CleanUIConfig_ConfigChanged();
        PlaySound("igInventoryOepn");
    end
end

function CleanUIConfig_VersionUpdate() 

    if (not CleanUIData.VERSION) then
        CleanUIData.VERSION = 0;
    end

    -- lter als Version 4.23
    if (CleanUIData.VERSION < 423) then  
        DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI|r version update:", 1.0, 1.0, 1.0, 1, 10);
        
        DEFAULT_CHAT_FRAME:AddMessage("    - reset frame borders", 1.0, 1.0, 1.0, 1, 10);
        CleanUIData.BORDER_STYLE = 1;
        CleanUIData.CUI_FRAME_BACKGROUND = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-background";
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border";
    end
     	
    -- lter als Version 4.24
    if (CleanUIData.VERSION < 424) then  
        DEFAULT_CHAT_FRAME:AddMessage("    - reset party frame positions", 1.0, 1.0, 1.0, 1, 10);
        for i = 1, 12 do
            CleanUIData.unitFramePositions["PartyMemberFrame"..i] = nil;
            CleanUIData.UNITFRAME_POSITIONS = 1;
        end
    end
    
    CleanUIData.VERSION = 424;
end

function CleanUIConfig_Init()
    CleanUIConfig_VersionUpdate();

    CleanUIConfig_CheckSave();
    
    UIDropDownMenu_Initialize(_G["CUIConfig_LoadName"], CleanUIConfig_LoadName_Initialize);

    CleanUIData.SCREENSHOT = CleanUIData.SCREENSHOT or 1;   
    CleanUIData.CHANGE_CHARACTERFRAME = CleanUIData.CHANGE_CHARACTERFRAME or 1;   
    
    CleanUIData.BORDER_STYLE = CleanUIData.BORDER_STYLE or 1; 
    CleanUIData.CUI_FRAME_BACKGROUND = CleanUIData.CUI_FRAME_BACKGROUND or "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-background"; 
    CleanUIData.CUI_FRAME_BORDER = CleanUIData.CUI_FRAME_BORDER or "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border";  
    CleanUIData.AUTO_CHANGE_BORDER_STYLE = CleanUIData.AUTO_CHANGE_BORDER_STYLE or 1;  

    CleanUIData.STATUSBAR_STYLE = CleanUIData.STATUSBAR_STYLE or 1;
    CleanUIData.CUI_STATUSBAR = CleanUIData.CUI_STATUSBAR or "Interface\\AddOns\\CleanUI\\skins\\StatusBar";
    CleanUIData.CUI_STATUSBAR_VERTICAL = CleanUIData.CUI_STATUSBAR_VERTICAL or "Interface\\AddOns\\CleanUI\\skins\\StatusBarVertical";
    
    CleanUIData.CHANGE_ACTIONBARS = CleanUIData.CHANGE_ACTIONBARS or 1; 
    CleanUIData.ACTIONBARS_SHOWMACRONAMES = CleanUIData.ACTIONBARS_SHOWMACRONAMES or 0; 
    CleanUIData.ACTIONBARS_SHOWSTATUS = CleanUIData.ACTIONBARS_SHOWSTATUS or 1;  
    CleanUIData.ACTIONBARS_SHOWSTATUSTEXT = CleanUIData.ACTIONBARS_SHOWSTATUSTEXT or 1; 
    CleanUIData.ACTIONBARS_STATUSPOSITION = CleanUIData.ACTIONBARS_STATUSPOSITION or 1; 
    CleanUIData.ACTIONBARS_STATUSWIDTH = CleanUIData.ACTIONBARS_STATUSWIDTH or 60; 
    CleanUIData.BUTTONFACADE_ACTIONBUTTONS = CleanUIData.BUTTONFACADE_ACTIONBUTTONS or 1;
    CleanUIData.VEHICLEBAR_STYLE = CleanUIData.VEHICLEBAR_STYLE or 2; 
    
    CleanUIData.ACTIONBARS_DEBUFFS = CleanUIData.ACTIONBARS_DEBUFFS or 1;
    CleanUIData.ACTIONBARS_DEBUFFS_R = CleanUIData.ACTIONBARS_DEBUFFS_R or 1;
    CleanUIData.ACTIONBARS_DEBUFFS_G = CleanUIData.ACTIONBARS_DEBUFFS_G or 0;
    CleanUIData.ACTIONBARS_DEBUFFS_B = CleanUIData.ACTIONBARS_DEBUFFS_B or 0;
    CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT or 2; 
    CleanUIData.BUTTONFACADE_BUFFS = CleanUIData.BUTTONFACADE_BUFFS or 1;
    CleanUIData.BIGGER_DEBUFFS = CleanUIData.BIGGER_DEBUFFS or 1;
    
    CleanUIData.CHANGE_BAGS = CleanUIData.CHANGE_BAGS or 1;
    CleanUIData.USE_BIGBAG = CleanUIData.USE_BIGBAG or 0;
    
    CleanUIData.USE_BIGBAG = 0;
    
    CleanUIData.BAGS_COLORIZE_ITEMS = CleanUIData.BAGS_COLORIZE_ITEMS or 1;
    CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = CleanUIData.BAGS_SHOW_WHITE_AS_GRAY or 1;
    CleanUIData.BAGS_MOVEBAGBUTTONS = CleanUIData.BAGS_MOVEBAGBUTTONS or 1;
    CleanUIData.BAGS_SHOWBACKBACKBUTTON = CleanUIData.BAGS_SHOWBACKBACKBUTTON or 0;
    CleanUIData.BAGS_AUTOREPAIR = CleanUIData.BAGS_AUTOREPAIR or 1;
    CleanUIData.BAGS_AUTOSELLGRAY = CleanUIData.BAGS_AUTOSELLGRAY or 1;
    CleanUIData.BAGPACK_MINIMAP_POS = CleanUIData.BAGPACK_MINIMAP_POS or 45;
    
    CleanUIData.CHANGE_CASTINGBARS = CleanUIData.CHANGE_CASTINGBARS or 1; 
    CleanUIData.CASTINGBARS_SHOWPETBAR = CleanUIData.CASTINGBARS_SHOWPETBAR or 1; 
    CleanUIData.CASTINGBARS_ALPHA = CleanUIData.CASTINGBARS_ALPHA or 1; 
    CleanUIData.CASTINGBARS_WIDTH = CleanUIData.CASTINGBARS_WIDTH or 300; 
    CleanUIData.CASTINGBARS_PLAYERHEIGHT = CleanUIData.CASTINGBARS_PLAYERHEIGHT or 24; 
    CleanUIData.CASTINGBARS_IMAGESIZE = CleanUIData.CASTINGBARS_IMAGESIZE or 24; 
    CleanUIData.CASTINGBARS_PETHEIGHT = CleanUIData.CASTINGBARS_PETHEIGHT or 16;  
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = CleanUIData.CASTINGBARS_GLOBALCOOLDOWN or 1;  
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT or 2;  
    CleanUIData.CASTINGBARS_LATENCY = CleanUIData.CASTINGBARS_LATENCY or 1;  
    
    CleanUIData.CHANGE_MINIMAP = CleanUIData.CHANGE_MINIMAP or 1;  
    CleanUIData.MAP_SHOWQUESTLEVEL = CleanUIData.MAP_SHOWQUESTLEVEL or 1;
    CleanUIData.MAP_SHOWSHIPROUTES = CleanUIData.MAP_SHOWSHIPROUTES or 1;
    
    CleanUIData.CHANGE_UNITFRAMES = CleanUIData.CHANGE_UNITFRAMES or 1;  
    CleanUIData.CHANGE_BOSSFRAMES = CleanUIData.CHANGE_BOSSFRAMES or 1;   
    CleanUIData.SHOW_DPS = CleanUIData.SHOW_DPS or 1;    
    CleanUIData.SHOW_DPSINFO = CleanUIData.SHOW_DPSINFO or 0;  
    CleanUIData.MERGEPETDPSDATA = CleanUIData.MERGEPETDPSDATA or 0;  
    CleanUIData.PORTRAIT_STYLE = CleanUIData.PORTRAIT_STYLE or 1;  
    CleanUIData.UNITFRAME_POSITIONS = CleanUIData.UNITFRAME_POSITIONS or 1;  
    
    CleanUIData.SHOW_XPFRAME = CleanUIData.SHOW_XPFRAME or 0;
    CleanUIData.SHOW_ORIG_XPBAR = CleanUIData.SHOW_ORIG_XPBAR or 1;
    CleanUIData.XPFRAME_WIDTH = CleanUIData.XPFRAME_WIDTH or 210;    
    CleanUIData.XPBAR_HEIGHT = CleanUIData.XPBAR_HEIGHT or 13;    
    CleanUIData.XPFRAME_X_XMAX = CleanUIData.XPFRAME_X_XMAX or 1;
    CleanUIData.XPFRAME_PERCENT = CleanUIData.XPFRAME_PERCENT or 1;
    CleanUIData.XPFRAME_MAXLEVEL = CleanUIData.XPFRAME_MAXLEVEL or 0;
    CleanUIData.XPFRAME_UNKNOWN = CleanUIData.XPFRAME_UNKNOWN or 0;
    
    CleanUIData.SHOW_THREATFRAME = CleanUIData.SHOW_THREATFRAME or 0;
    CleanUIData.THREATFRAME_RAWPCT = CleanUIData.THREATFRAME_RAWPCT or 1;
    CleanUIData.THREATFRAME_ALPHA = CleanUIData.THREATFRAME_ALPHA or 1;

    CleanUIData.CHANGE_CHAT = CleanUIData.CHANGE_CHAT or 1;
    CleanUIData.DISABLE_ALTARROWKEYMODE = CleanUIData.DISABLE_ALTARROWKEYMODE or 1;
    CleanUIData.SHOW_CHAT_ACTIONBAR = CleanUIData.SHOW_CHAT_ACTIONBAR or 1;
    CleanUIData.SHOW_CHAT_EMOTICONS = CleanUIData.SHOW_CHAT_EMOTICONS or 1;
    
    CleanUIData.CHANGE_RAID = CleanUIData.CHANGE_RAID or 1;
    
    CleanUIData.TOOLTIPS_HIDEINCOMBAT = CleanUIData.TOOLTIPS_HIDEINCOMBAT or 0;
    CleanUIData.TOOLTIPS_POSITION = CleanUIData.TOOLTIPS_POSITION or 1;
    
    CleanUIData.CHANGE_NAMEPLATES = CleanUIData.CHANGE_NAMEPLATES or 1;
    CleanUIData.NAMEPLATES_PERCENT = CleanUIData.NAMEPLATES_PERCENT or 1;
    CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = CleanUIData.NAMEPLATES_HIGHLIGHTTARGET or 1;
    CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS or 1;
    
    CleanUIData.SHOW_DATABROKER = CleanUIData.SHOW_DATABROKER or 1;
    CleanUIData.DATABROKER_COUNTROWS = CleanUIData.DATABROKER_COUNTROWS or 2;

    CleanUIData.DataBroker_Disabled = CleanUIData.DataBroker_Disabled or {};
    
    CleanUIConfig_InitDataBroker();
end

function CleanUIConfig_InitDataBroker()
    
    local count = 0;    
    local row = 0;  
    local column = 0;
    
    local x_offset = 40;
    local y_offset = 40;
    
    local x, y;

    for name, button in pairs(db_buttons) do 
        
        local dataobj = button.dataobj;
        
        local name = "CUIConfig_DataBroker_ToggleButton"..count;
        
        local checkbutton = _G[name];
        if (not checkbutton) then
            checkbutton = CreateFrame("CheckButton", name, CUIConfigDataBroker, "OptionsCheckButtonTemplate");
            checkbutton:SetWidth(32);
            checkbutton:SetHeight(32);
            checkbutton:SetHitRectInsets(0, 0, 0, 0);
            checkbutton:HookScript("OnEnter", CleanUIConfig_DataBroker_OnEnter);
            checkbutton:HookScript("OnLeave", CleanUIConfig_DataBroker_OnLeave);
            checkbutton:HookScript("OnClick", CleanUIConfig_DataBroker_OnClick);
        end
	
        checkbutton:SetNormalTexture(dataobj.icon);
        checkbutton:SetPushedTexture(dataobj.icon);
        checkbutton:SetHighlightTexture(nil);
        checkbutton.dataobj = dataobj;
        
        column = mod(count, 10);            
        if (column == 0) then
            row = row + 1;
        end
            
        x = column * x_offset;
        y = row * y_offset;
        
        checkbutton:ClearAllPoints();
        checkbutton:SetPoint("TOPLEFT", CUIConfig_ConfigActionsTitle, "TOPLEFT", x, -y);
        
        local checked = CleanUIData.DataBroker_Disabled[dataobj.cui_name] ~= 1;
        checkbutton:SetChecked(checked);
        
        count = count + 1;
    end
end

function CleanUIConfig_DataBroker_OnClick(self) 
    local dataobj = self.dataobj;
    local name = dataobj.cui_name;
    
    if (self:GetChecked()) then
        CleanUIData.DataBroker_Disabled[name] = 0;
    else
        CleanUIData.DataBroker_Disabled[name] = 1;
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_DataBroker_OnEnter(self)
    local dataobj = self.dataobj;
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOM");
    GameTooltip:SetText(dataobj.cui_name);
    GameTooltip:Show();
end

function CleanUIConfig_DataBroker_OnLeave()
	GameTooltip:Hide();
end

function CleanUIConfig_Reset() 
    CleanUIConfig_LoadDefaultUnitFramePositions();
    
    CleanUIData.SCREENSHOT = 1;
    CleanUIData.CHANGE_CHARACTERFRAME = 1;
    
    CleanUIData.BORDER_STYLE = 1;
    CleanUIData.CUI_FRAME_BACKGROUND = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-background";
    CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border";
    CleanUIData.AUTO_CHANGE_BORDER_STYLE = 1;

    CleanUIData.STATUSBAR_STYLE = 1;
    CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\StatusBar";
    CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\StatusBarVertical";
    
    CleanUIData.CHANGE_ACTIONBARS = 1;
    CleanUIData.ACTIONBARS_SHOWMACRONAMES = 0;
    CleanUIData.ACTIONBARS_SHOWSTATUS = 1;
    CleanUIData.ACTIONBARS_SHOWSTATUSTEXT = 1;
    CleanUIData.ACTIONBARS_STATUSPOSITION = 1;
    CleanUIData.ACTIONBARS_STATUSWIDTH = 60;
    CleanUIData.BUTTONFACADE_ACTIONBUTTONS = 1;
    CleanUIData.VEHICLEBAR_STYLE = 2;
    
    CleanUIData.ACTIONBARS_DEBUFFS = 1;
    CleanUIData.ACTIONBARS_DEBUFFS_R = 1;
    CleanUIData.ACTIONBARS_DEBUFFS_G = 0;
    CleanUIData.ACTIONBARS_DEBUFFS_B = 0;
    CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = 2;
    CleanUIData.BUTTONFACADE_BUFFS = 1;
    CleanUIData.BIGGER_DEBUFFS = 1;
    
    CleanUIData.CHANGE_BAGS = 1;
    CleanUIData.USE_BIGBAG = 0;
    CleanUIData.BAGS_COLORIZE_ITEMS = 1;
    CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = 1;
    CleanUIData.BAGS_MOVEBAGBUTTONS = 1;
    CleanUIData.BAGS_SHOWBACKBACKBUTTON = 0;
    CleanUIData.BAGS_AUTOREPAIR = 1;
    CleanUIData.BAGS_AUTOSELLGRAY = 1;
    CleanUIData.BAGPACK_MINIMAP_POS = 45;
    
    CleanUIData.CHANGE_CASTINGBARS = 1;
    CleanUIData.CASTINGBARS_SHOWPETBAR = 1;
    CleanUIData.CASTINGBARS_ALPHA = 1;
    CleanUIData.CASTINGBARS_WIDTH = 300;
    CleanUIData.CASTINGBARS_PLAYERHEIGHT = 24;
    CleanUIData.CASTINGBARS_IMAGESIZE = 24;
    CleanUIData.CASTINGBARS_PETHEIGHT = 16;
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = 1;
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = 2;
    CleanUIData.CASTINGBARS_LATENCY = 1;
    
    CleanUIData.CHANGE_MINIMAP = 1;
    CleanUIData.MAP_SHOWQUESTLEVEL = 1;
    CleanUIData.MAP_SHOWSHIPROUTES = 1;
    
    CleanUIData.CHANGE_UNITFRAMES = 1;
    CleanUIData.CHANGE_BOSSFRAMES = 1;
    CleanUIData.SHOW_DPS = 1;
    CleanUIData.SHOW_DPSINFO = 0;
    CleanUIData.MERGEPETDPSDATA = 0;
    CleanUIData.PORTRAIT_STYLE = 1;
    CleanUIData.UNITFRAME_POSITIONS = 1;
    
    CleanUIData.SHOW_XPFRAME = 0;
    CleanUIData.SHOW_ORIG_XPBAR = 1;
    CleanUIData.XPFRAME_WIDTH = 210;
    CleanUIData.XPBAR_HEIGHT = 13;
    CleanUIData.XPFRAME_X_XMAX = 1;
    CleanUIData.XPFRAME_PERCENT = 1;
    CleanUIData.XPFRAME_MAXLEVEL = 0;
    CleanUIData.XPFRAME_UNKNOWN = 0;
    
    CleanUIData.SHOW_THREATFRAME = 0;
    CleanUIData.THREATFRAME_RAWPCT = 1;
    CleanUIData.THREATFRAME_ALPHA = 1;

    CleanUIData.CHANGE_CHAT = 1;
    CleanUIData.DISABLE_ALTARROWKEYMODE = 1;
    CleanUIData.SHOW_CHAT_ACTIONBAR = 1;
    CleanUIData.SHOW_CHAT_EMOTICONS = 1;
    
    CleanUIData.CHANGE_RAID = 1;
    
    CleanUIData.TOOLTIPS_HIDEINCOMBAT = 0;
    CleanUIData.TOOLTIPS_POSITION = 1;
    
    CleanUIData.CHANGE_NAMEPLATES = 1;
    CleanUIData.NAMEPLATES_PERCENT = 1;
    CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = 1;
    CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = 1;
    
    CleanUIData.SHOW_DATABROKER = 1;
    CleanUIData.DATABROKER_COUNTROWS = 2;
    
    CleanUIData.DataBroker_Disabled = {};

    -- initialize
    CleanUIConfig_Init();        
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ConfigChanged()
    InterfaceOptionsFrame.gameRestart = true;
    CleanUIConfig_ReloadConfig();
end

function CleanUIConfig_ReloadConfig() 

    if (not cui_config_loaded) then
        return;
    end
    
    CleanUIConfig_Init();
    
    _G["CUIConfig_ToggleScreenshot"]:SetChecked(CleanUIData.SCREENSHOT);
    _G["CUIConfig_ToggleCharacterFrame"]:SetChecked(CleanUIData.CHANGE_CHARACTERFRAME);
    
    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_BorderStyleDropDown"], CleanUIData.BORDER_STYLE);
	UIDropDownMenu_SetText(_G["CUIConfig_BorderStyleDropDown"], BORDER_STYLE[CleanUIData.BORDER_STYLE]);
    _G["CUIConfig_ToggleAutoChangeBorderStyle"]:SetChecked(CleanUIData.AUTO_CHANGE_BORDER_STYLE);
    
    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_StatusBarStyleDropDown"], CleanUIData.STATUSBAR_STYLE);
	UIDropDownMenu_SetText(_G["CUIConfig_StatusBarStyleDropDown"], STATUSBAR_STYLE[CleanUIData.STATUSBAR_STYLE]);
    
    _G["CUIConfig_ToggleCleanActionBars"]:SetChecked(CleanUIData.CHANGE_ACTIONBARS);
    _G["CUIConfig_ToggleMacroNames"]:SetChecked(CleanUIData.ACTIONBARS_SHOWMACRONAMES);
    _G["CUIConfig_TogglePlayerStatusBars"]:SetChecked(CleanUIData.ACTIONBARS_SHOWSTATUS);
    _G["CUIConfig_TogglePlayerStatusBarText"]:SetChecked(CleanUIData.ACTIONBARS_SHOWSTATUSTEXT);
    _G["CUIConfig_TogglePlayerStatusBarPosition"]:SetChecked(CleanUIData.ACTIONBARS_STATUSPOSITION);
    _G["CUIConfig_SelectPlayerStatusBarWidth"]:SetValue(CleanUIData.ACTIONBARS_STATUSWIDTH);
    _G["CUIConfig_SelectPlayerStatusBarWidthValue"]:SetText(format("%.0f", CleanUIData.ACTIONBARS_STATUSWIDTH));
    _G["CUIConfig_ToggleButtonFacadeForActionButtons"]:SetChecked(CleanUIData.BUTTONFACADE_ACTIONBUTTONS);
    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_VehicleBarStyleDropDown"], CleanUIData.VEHICLEBAR_STYLE);
    UIDropDownMenu_SetText(_G["CUIConfig_VehicleBarStyleDropDown"], VEHICLEBAR_STYLE[CleanUIData.VEHICLEBAR_STYLE]);

    _G["CUIConfig_ToggleDeBuffsForActionButtons"]:SetChecked(CleanUIData.ACTIONBARS_DEBUFFS);
    _G["CleanUIDeBuffsBarColorExample"]:SetStatusBarColor(CleanUIData.ACTIONBARS_DEBUFFS_R, CleanUIData.ACTIONBARS_DEBUFFS_G, CleanUIData.ACTIONBARS_DEBUFFS_B);
    _G["CUIConfig_DeBuffsBarHeight"]:SetValue(CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT);
    _G["CUIConfig_DeBuffsBarHeightValue"]:SetText(format("%.0f", CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT));
    _G["CUIConfig_ToggleButtonFacadeForBuffs"]:SetChecked(CleanUIData.BUTTONFACADE_BUFFS);
    _G["CUIConfig_ToggleBiggerDebuffs"]:SetChecked(CleanUIData.BIGGER_DEBUFFS);
    
    _G["CUIConfig_ToggleChangeBags"]:SetChecked(CleanUIData.CHANGE_BAGS);
    _G["CUIConfig_ToggleUseBigBag"]:SetChecked(CleanUIData.USE_BIGBAG);
    _G["CUIConfig_ToggleColorizeItems"]:SetChecked(CleanUIData.BAGS_COLORIZE_ITEMS);
    _G["CUIConfig_ToggleShowWhiteAsGray"]:SetChecked(CleanUIData.BAGS_SHOW_WHITE_AS_GRAY);
    _G["CUIConfig_ToggleMoveBagButtons"]:SetChecked(CleanUIData.BAGS_MOVEBAGBUTTONS);
    _G["CUIConfig_ToggleShowBackpackButton"]:SetChecked(CleanUIData.BAGS_SHOWBACKBACKBUTTON);
    _G["CUIConfig_ToggleBagsAutoRepair"]:SetChecked(CleanUIData.BAGS_AUTOREPAIR);
    _G["CUIConfig_ToggleBagsAutoSellGray"]:SetChecked(CleanUIData.BAGS_AUTOSELLGRAY);
    
    _G["CUIConfig_ToggleChangeCastingBars"]:SetChecked(CleanUIData.CHANGE_CASTINGBARS);
    _G["CUIConfig_ToggleCastingBarsShowPetBar"]:SetChecked(CleanUIData.CASTINGBARS_SHOWPETBAR);
    _G["CUIConfig_SelectCastingBarAlpha"]:SetValue(CleanUIData.CASTINGBARS_ALPHA);
    _G["CUIConfig_SelectCastingBarAlphaValue"]:SetText(format("%.2f", CleanUIData.CASTINGBARS_ALPHA));
    _G["CUIConfig_SelectCastingBarWidth"]:SetValue(CleanUIData.CASTINGBARS_WIDTH);
    _G["CUIConfig_SelectCastingBarWidthValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_WIDTH));
    _G["CUIConfig_SelectPlayerCastingBarHeight"]:SetValue(CleanUIData.CASTINGBARS_PLAYERHEIGHT);
    _G["CUIConfig_SelectPlayerCastingBarHeightValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_PLAYERHEIGHT));
    _G["CUIConfig_SelectPlayerCastingBarImageSize"]:SetValue(CleanUIData.CASTINGBARS_IMAGESIZE);
    _G["CUIConfig_SelectPlayerCastingBarImageSizeValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_IMAGESIZE));
    _G["CUIConfig_SelectPetCastingBarHeight"]:SetValue(CleanUIData.CASTINGBARS_PETHEIGHT);
    _G["CUIConfig_SelectPetCastingBarHeightValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_PETHEIGHT));
    _G["CUIConfig_ToggleCastingBarsShowGlobalCooldown"]:SetChecked(CleanUIData.CASTINGBARS_GLOBALCOOLDOWN);
    _G["CUIConfig_SelectGlobalCooldownHeight"]:SetValue(CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT);
    _G["CUIConfig_SelectGlobalCooldownHeightValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT));
    _G["CUIConfig_ToggleCastingBarsShowLatency"]:SetChecked(CleanUIData.CASTINGBARS_LATENCY);
    
    _G["CUIConfig_ToggleCleanMinimap"]:SetChecked(CleanUIData.CHANGE_MINIMAP);
    _G["CUIConfig_ToggleMapLevel"]:SetChecked(CleanUIData.MAP_SHOWQUESTLEVEL);
    _G["CUIConfig_ToggleMapRoutes"]:SetChecked(CleanUIData.MAP_SHOWSHIPROUTES);
    
    _G["CUIConfig_ToggleCleanUnitFrames"]:SetChecked(CleanUIData.CHANGE_UNITFRAMES);
    _G["CUIConfig_ToggleCleanBossFrames"]:SetChecked(CleanUIData.CHANGE_BOSSFRAMES);
    _G["CUIConfig_ToggleShowDpsFrame"]:SetChecked(CleanUIData.SHOW_DPS);
    _G["CUIConfig_ToggleShowDpsFrameInfo"]:SetChecked(CleanUIData.SHOW_DPSINFO);
    _G["CUIConfig_ToggleMergePetDpsData"]:SetChecked(CleanUIData.MERGEPETDPSDATA);
    
    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_PortraitStyleDropDown"], CleanUIData.PORTRAIT_STYLE);
	UIDropDownMenu_SetText(_G["CUIConfig_PortraitStyleDropDown"], PORTRAIT_TYPE[CleanUIData.PORTRAIT_STYLE]);
    
    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_UnitFramePositionsDropDown"], CleanUIData.UNITFRAME_POSITIONS);
	UIDropDownMenu_SetText(_G["CUIConfig_UnitFramePositionsDropDown"], UNITFRAME_POSITION_TYPE[CleanUIData.UNITFRAME_POSITIONS]);
    
    _G["CUIConfig_ToggleXpFrame"]:SetChecked(CleanUIData.SHOW_XPFRAME);
    _G["CUIConfig_ToggleOrigXpBar"]:SetChecked(CleanUIData.SHOW_ORIG_XPBAR);
    _G["CUIConfig_SelectXpFrameWidth"]:SetValue(CleanUIData.XPFRAME_WIDTH);
    _G["CUIConfig_SelectXpFrameWidthValue"]:SetText(format("%.0f", CleanUIData.XPFRAME_WIDTH));
    _G["CUIConfig_SelectXpBarHeight"]:SetValue(CleanUIData.XPBAR_HEIGHT);
    _G["CUIConfig_SelectXpBarHeightValue"]:SetText(format("%.0f", CleanUIData.XPBAR_HEIGHT));
    _G["CUIConfig_ToggleXpFrame_X_Xmax"]:SetChecked(CleanUIData.XPFRAME_X_XMAX);
    _G["CUIConfig_ToggleXpFrame_Percent"]:SetChecked(CleanUIData.XPFRAME_PERCENT);
    _G["CUIConfig_ToggleXpFrame_MaxLevel"]:SetChecked(CleanUIData.XPFRAME_MAXLEVEL);
    _G["CUIConfig_ToggleXpFrame_Unknown"]:SetChecked(CleanUIData.XPFRAME_UNKNOWN);
    
    _G["CUIConfig_ToggleThreatFrame"]:SetChecked(CleanUIData.SHOW_THREATFRAME);    
    _G["CUIConfig_SelectThreatType"]:SetValue(CleanUIData.THREATFRAME_RAWPCT);
    _G["CUIConfig_SelectThreatAlpha"]:SetValue(CleanUIData.THREATFRAME_ALPHA);    
    _G["CUIConfig_SelectThreatAlphaValue"]:SetText(format("%.2f", CleanUIData.THREATFRAME_ALPHA));
    
    _G["CUIConfig_ToggleChangeChat"]:SetChecked(CleanUIData.CHANGE_CHAT);   
    _G["CUIConfig_ToggleDisableAltArrowKeyMode"]:SetChecked(CleanUIData.DISABLE_ALTARROWKEYMODE); 
    _G["CUIConfig_ToggleShowChatActionBar"]:SetChecked(CleanUIData.SHOW_CHAT_ACTIONBAR);   
    _G["CUIConfig_ToggleShowChatEmoticons"]:SetChecked(CleanUIData.SHOW_CHAT_EMOTICONS);  
    
    _G["CUIConfig_ToggleChangeRaid"]:SetChecked(CleanUIData.CHANGE_RAID);   
    
    _G["CUIConfig_ToggleChangeNameplates"]:SetChecked(CleanUIData.CHANGE_NAMEPLATES);   
    _G["CUIConfig_ToggleNameplatesPercent"]:SetChecked(CleanUIData.NAMEPLATES_PERCENT);   
    _G["CUIConfig_ToggleNameplatesHighlightTarget"]:SetChecked(CleanUIData.NAMEPLATES_HIGHLIGHTTARGET);  
    _G["CUIConfig_ToggleNameplatesComboPoints"]:SetChecked(CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS);   
    
    _G["CUIConfig_ToggleShowDataBroker"]:SetChecked(CleanUIData.SHOW_DATABROKER);   
    _G["CUIConfig_SelectDataBrokerCountRows"]:SetValue(CleanUIData.DATABROKER_COUNTROWS);    
    _G["CUIConfig_SelectDataBrokerCountRowsValue"]:SetText(format("%.0f", CleanUIData.DATABROKER_COUNTROWS));
    
    if (CleanUIData.CHANGE_ACTIONBARS == 1) then 
        _G["CUIConfig_ToggleOrigXpBar"]:Enable();
    else
        _G["CUIConfig_ToggleOrigXpBar"]:Disable();
    end
    
    if (CleanUIData.BAGS_MOVEBAGBUTTONS == 1) then 
        _G["CUIConfig_ToggleShowBackpackButton"]:Enable();
    else
        _G["CUIConfig_ToggleShowBackpackButton"]:Disable();
    end
    
    if (CleanUIData.USE_BIGBAG == 1) then 
        _G["CUIConfig_ToggleMoveBagButtons"]:Disable();
    else
        _G["CUIConfig_ToggleMoveBagButtons"]:Enable();
    end
    
    if (CleanUIData.BAGS_COLORIZE_ITEMS == 1) then 
        _G["CUIConfig_ToggleShowWhiteAsGray"]:Enable();
    else
        _G["CUIConfig_ToggleShowWhiteAsGray"]:Disable();
    end
    
    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_TooltipPositionDropDown"], CleanUIData.TOOLTIPS_POSITION);
	UIDropDownMenu_SetText(_G["CUIConfig_TooltipPositionDropDown"], TOOLTIPS_POSITION[CleanUIData.TOOLTIPS_POSITION]);
    _G["CUIConfig_ToggleHideTooltipsInCombat"]:SetChecked(CleanUIData.TOOLTIPS_HIDEINCOMBAT);
    
    -- update the ui
    CleanUIConfig_InitBorderStyle();
    CleanUIConfig_InitStatusBarStyle();
    CleanUIConfig_InitVehicleBarStyle();
    CleanUI_MoveBagButtons();
    CleanUI_RescaleActionButtonFrame();
    CleanUI_DataBroker_ShowButtons();
end

function CleanUIConfig_InitBorderStyle() 
    CleanUIData.CUI_FRAME_BACKGROUND = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-background";
    CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border";

    if (CleanUIData.BORDER_STYLE == 2) then
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border_white";
    elseif (CleanUIData.BORDER_STYLE == 3) then
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border_black";
    elseif (CleanUIData.BORDER_STYLE == 4) then
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border";
    elseif (CleanUIData.BORDER_STYLE == 5) then
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border_yellow";
    elseif (CleanUIData.BORDER_STYLE == 6) then
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border_red";
    elseif (CleanUIData.BORDER_STYLE == 7) then
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border_green";
    elseif (CleanUIData.BORDER_STYLE == 8) then
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border_blue";
    elseif (CleanUIData.BORDER_STYLE == 9) then
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border_yellow_dark";
    elseif (CleanUIData.BORDER_STYLE == 10) then
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border_red_dark";
    elseif (CleanUIData.BORDER_STYLE == 11) then
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border_green_dark";
    elseif (CleanUIData.BORDER_STYLE == 12) then
        CleanUIData.CUI_FRAME_BORDER = "Interface\\AddOns\\CleanUI\\skins\\frame\\frame-border_blue_dark";
    end
    
    CleanUI_ReplaceAllBorderTextures("UI-Tooltip-Border", UIParent);
    CleanUI_ReplaceAllBorderTextures("frame-border", UIParent);
end

function CleanUIConfig_InitStatusBarStyle() 
    CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\StatusBar";
    CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\StatusBarVertical";
    
    if (CleanUIData.STATUSBAR_STYLE >= 2) then
        CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\"..STATUSBAR_STYLE[CleanUIData.STATUSBAR_STYLE];
        CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\"..STATUSBAR_STYLE[CleanUIData.STATUSBAR_STYLE].."Vertical";
    end
    
    CleanUI_InitStatusBarTexture();
end

function CleanUIConfig_InitVehicleBarStyle() 
    CleanUI_ChangeVehicleButtonBarLayout();
end

function CleanUIConfig_LoadDefaultUnitFramePositions() 
    if (InCombatLockdown()) then
        return;
    end

 	DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r load default unit frame positions", 1.0, 1.0, 1.0, 1, 10);
 	
    CleanUI_SaveFramePosition(PlayerFrame, "TOPLEFT", UIParent, "TOPLEFT", 5, -10);
    CleanUI_SaveFramePosition(TargetFrame, "TOPLEFT", UIParent, "TOPLEFT", 300, -10);
    CleanUI_SaveFramePosition(FocusFrame, "TOPLEFT", UIParent, "TOPLEFT", 595, -10);
	CleanUI_SaveFramePosition(PartyMemberFrame1, "TOPLEFT", UIParent, "TOPLEFT", 25, -160);
	CleanUI_SaveFramePosition(PartyMemberFrame2, "TOPLEFT", UIParent, "TOPLEFT", 25, -240);
	CleanUI_SaveFramePosition(PartyMemberFrame3, "TOPLEFT", UIParent, "TOPLEFT", 25, -320);
	CleanUI_SaveFramePosition(PartyMemberFrame4, "TOPLEFT", UIParent, "TOPLEFT", 25, -400);
end

function CleanUIConfig_LoadBattleUnitFramePositions() 
    if (InCombatLockdown()) then
        return;
    end

 	DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r load battle unit frame positions", 1.0, 1.0, 1.0, 1, 10);
 	
    CleanUI_SaveFramePosition(PlayerFrame, "TOPLEFT", CleanUIActionButtonsArtFrame, "TOPLEFT", -20, 350);
    CleanUI_SaveFramePosition(TargetFrame, "TOPRIGHT", CleanUIActionButtonsArtFrame, "TOPRIGHT", 20, 350);
    CleanUI_SaveFramePosition(FocusFrame, "TOPLEFT", TargetFrame, "TOPRIGHT", 10, 75);
	CleanUI_SaveFramePosition(PartyMemberFrame1, "TOPLEFT", UIParent, "TOPLEFT", 25, -160);
	CleanUI_SaveFramePosition(PartyMemberFrame2, "TOPLEFT", UIParent, "TOPLEFT", 25, -240);
	CleanUI_SaveFramePosition(PartyMemberFrame3, "TOPLEFT", UIParent, "TOPLEFT", 25, -320);
	CleanUI_SaveFramePosition(PartyMemberFrame4, "TOPLEFT", UIParent, "TOPLEFT", 25, -400);
end

function CleanUIConfig_OnLoad(self)
 	DEFAULT_CHAT_FRAME:AddMessage("|c333399ffNirriti's |rCleanUI Config loaded.", 1.0, 1.0, 1.0, 1, 10);
 	
 	-- Hauptfenster
	self.name="CleanUI";
    self.addonname = "CleanUI";
    InterfaceOptions_AddCategory(self);
    
    -- actionbars
	local actionBars = getglobal("CUIConfigActionBars");
	actionBars.name = CONFIG_ACTIONBARS_TITLE;
	actionBars.parent = "CleanUI";
    actionBars.addonname = "CleanUI";
    InterfaceOptions_AddCategory(actionBars);
    
    -- buffs and debuffs
	local debuffs = getglobal("CUIConfigDeBuffs");
	debuffs.name = CONFIG_DEBUFFS_TITLE;
	debuffs.parent = "CleanUI";
    debuffs.addonname = "CleanUI";
    InterfaceOptions_AddCategory(debuffs);
    
    -- minimap
	local castingbars = getglobal("CUIConfigCastingBars");
	castingbars.name = CONFIG_CASTINGBARS_TITLE;
	castingbars.parent = "CleanUI";
    castingbars.addonname = "CleanUI";
    InterfaceOptions_AddCategory(castingbars);
    
    -- minimap
	local minimap = getglobal("CUIConfigMinimap");
	minimap.name = CONFIG_MINIMAP_TITLE;
	minimap.parent = "CleanUI";
    minimap.addonname = "CleanUI";
    InterfaceOptions_AddCategory(minimap);
    
    -- unit frames
	local unitframes = getglobal("CUIConfigUnitFrames");
	unitframes.name = CONFIG_UNITFRAMES_TITLE;
	unitframes.parent = "CleanUI";
    unitframes.addonname = "CleanUI";
    InterfaceOptions_AddCategory(unitframes);
    
    -- raid frames
	local raidframes = getglobal("CUIConfigRaidFrames");
	raidframes.name = CONFIG_RAID_TITLE;
	raidframes.parent = "CleanUI";
    raidframes.addonname = "CleanUI";
    InterfaceOptions_AddCategory(raidframes);
    
    -- xp bars
	local xpbars = getglobal("CUIConfigXpBars");
	xpbars.name = CONFIG_XPBARS_TITLE;
	xpbars.parent = "CleanUI";
    xpbars.addonname = "CleanUI";
    InterfaceOptions_AddCategory(xpbars);
    
    -- bags
	local bags = getglobal("CUIConfigBags");
	bags.name = CONFIG_BAGS_TITLE;
	bags.parent = "CleanUI";
    bags.addonname = "CleanUI";
    InterfaceOptions_AddCategory(bags);
    
    -- threat frame
	local threatframe = getglobal("CUIConfigThreatFrame");
	threatframe.name = CONFIG_THREATFRAME_TITLE;
	threatframe.parent = "CleanUI";
    threatframe.addonname = "CleanUI";
    InterfaceOptions_AddCategory(threatframe);
    
    -- chat
	local chat = getglobal("CUIConfigChat");
	chat.name = CONFIG_CHAT_TITLE;
	chat.parent = "CleanUI";
    chat.addonname = "CleanUI";
    InterfaceOptions_AddCategory(chat);
    
    -- tooltips
	local tooltips = getglobal("CUIConfigTooltips");
	tooltips.name = CONFIG_TOOLTIP_TITLE;
	tooltips.parent = "CleanUI";
    tooltips.addonname = "CleanUI";
    InterfaceOptions_AddCategory(tooltips);
    
    -- nameplates
	local nameplates = getglobal("CUIConfigNameplates");
	nameplates.name = CONFIG_NAMEPLATES_TITLE;
	nameplates.parent = "CleanUI";
    nameplates.addonname = "CleanUI";
    InterfaceOptions_AddCategory(nameplates);
    
    -- plugins
	local plugins = getglobal("CUIConfigDataBroker");
	plugins.name = CONFIG_DATABROKER_TITLE;
	plugins.parent = "CleanUI";
    plugins.addonname = "CleanUI";
    InterfaceOptions_AddCategory(plugins);
    
    -- basic info
    local author = GetAddOnMetadata("CleanUI", "Author");
    local version = GetAddOnMetadata("CleanUI", "Version");
    
    local optionsTitle = _G["CUIConfig_OptionsTitle"];
    optionsTitle:SetText("CleanUI v"..version);
    
    local optionsAuthor = _G["CUIConfig_OptionsAuthor"];
    optionsAuthor:SetText("("..author..")");
    
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("CVAR_UPDATE");
	
	cui_config_loaded = true;
end

function CUIConfig_BorderStyleDropDown_Initialize(self)
	local selectedValue = UIDropDownMenu_GetSelectedValue(self);
	
	for i = 1, #BORDER_STYLE do
        local info = UIDropDownMenu_CreateInfo();
        info.text = BORDER_STYLE[i];
        info.value = i;
        info.func = function()
                CleanUIConfig_ToggleBorderStyle(i);
            end
        UIDropDownMenu_AddButton(info);
	end
end

function CUIConfig_StatusBarStyleDropDown_Initialize(self)
	local selectedValue = UIDropDownMenu_GetSelectedValue(self);
	
	for i = 1, #STATUSBAR_STYLE do
        local info = UIDropDownMenu_CreateInfo();
        info.text = STATUSBAR_STYLE[i];
        info.value = i;
        info.func = function()
                CleanUIConfig_ToggleStatusBarStyle(i);
            end
        UIDropDownMenu_AddButton(info);
	end
end

function CUIConfig_VehicleBarStyleDropDown_Initialize(self)
    local selectedValue = UIDropDownMenu_GetSelectedValue(self);
    
    for i = 1, #VEHICLEBAR_STYLE do
        local info = UIDropDownMenu_CreateInfo();
        info.text = VEHICLEBAR_STYLE[i];
        info.value = i;
        info.func = function()
                CleanUIConfig_ToggleVehicleBarStyle(i);
            end
        UIDropDownMenu_AddButton(info);
    end
end

function CUIConfig_TooltipPositionDropDown_Initialize(self)
	local selectedValue = UIDropDownMenu_GetSelectedValue(self);
	
	for i = 1, #TOOLTIPS_POSITION do
        local info = UIDropDownMenu_CreateInfo();
        info.text = TOOLTIPS_POSITION[i];
        info.value = i;
        info.func = function()
                CleanUIConfig_ToggleTooltipPosition(i);
            end
        UIDropDownMenu_AddButton(info);
	end
end

function CleanUIConfig_InterfaceOptionsFrame_Show()
    if ( InterfaceOptionsFrame:IsShown() ) then
        CleanUIConfig_ReloadConfig();
    end

    CUI_CONFIG_SHOWN = true;
end

function CleanUIConfig_InterfaceOptionsFrame_Hide()
    CUI_CONFIG_SHOWN = false;
    
    -- Aufrumen!
    CleanUI_HideCastingBars();
end

function CleanUIConfig_OnEvent(self, event, ...)
    if (event == "CVAR_UPDATE") then
        local name, value = ...;
 	    --DEFAULT_CHAT_FRAME:AddMessage("CVAR_UPDATE   "..name.." = "..value, 1.0, 1.0, 1.0, 1, 10);
    end
end

-- settings

function CleanUIConfig_ToggleBorderStyle(index)
 	CleanUIData.BORDER_STYLE = index;
 	DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r border style set to "..BORDER_STYLE[index], 1.0, 1.0, 1.0, 1, 10);
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleTooltipPosition(index)
 	CleanUIData.TOOLTIPS_POSITION = index;
 	DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r tooltip position set to "..TOOLTIPS_POSITION[index], 1.0, 1.0, 1.0, 1, 10);
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleVehicleBarStyle(index)
    CleanUIData.VEHICLEBAR_STYLE = index;
    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r vehible bar style set to "..VEHICLEBAR_STYLE[index], 1.0, 1.0, 1.0, 1, 10);
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleAutoChangeBorderStyle()
    if (CleanUIData.AUTO_CHANGE_BORDER_STYLE == 1) then
        CleanUIData.AUTO_CHANGE_BORDER_STYLE = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't change border style automatically", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.AUTO_CHANGE_BORDER_STYLE = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r change border style automatically", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleStatusBarStyle(index)
 	CleanUIData.STATUSBAR_STYLE = index;
 	DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r statusbar style set to "..STATUSBAR_STYLE[index], 1.0, 1.0, 1.0, 1, 10);
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleScreenshot()
    if (CleanUIData.SCREENSHOT == 1) then
        CleanUIData.SCREENSHOT = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r no screenshots", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.SCREENSHOT = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r auto screenshots", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCharacterFrame()
    if (CleanUIData.CHANGE_CHARACTERFRAME == 1) then
        CleanUIData.CHANGE_CHARACTERFRAME = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't change character frame", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CHANGE_CHARACTERFRAME = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r change character frame", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleXpFrame()
    if (CleanUIData.SHOW_XPFRAME == 1) then
        CleanUIData.SHOW_XPFRAME = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide xp frame", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.SHOW_XPFRAME = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show xp frame", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleOrigXpBar()
    if (CleanUIData.SHOW_ORIG_XPBAR == 1) then
        CleanUIData.SHOW_ORIG_XPBAR = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide blizzard xp bar", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.SHOW_ORIG_XPBAR = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show blizzard xp bar", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_UpdateActionBars();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_SelectXpFrameWidth(self)

    if (CleanUIData.XPFRAME_WIDTH ~= self:GetValue()) then
        CleanUIData.XPFRAME_WIDTH = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CleanUIXpFrame) then
            CleanUI_CleanXpFrame();
        end
    end
end

function CleanUIConfig_SelectXpBarHeight(self)

    if (CleanUIData.XPBAR_HEIGHT ~= self:GetValue()) then
        CleanUIData.XPBAR_HEIGHT = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CleanUIXpFrame) then
            CleanUI_CleanXpFrame();
        end
    end
end

function CleanUIConfig_ToggleXpFrame_X_Xmax()
    if (CleanUIData.XPFRAME_X_XMAX == 1) then
        CleanUIData.XPFRAME_X_XMAX = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide X/XMAX", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.XPFRAME_X_XMAX = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show X/XMAX", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleXpFrame_Percent()
    if (CleanUIData.XPFRAME_PERCENT == 1) then
        CleanUIData.XPFRAME_PERCENT = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide percent", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.XPFRAME_PERCENT = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show percent", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleXpFrame_MaxLevel()
    if (CleanUIData.XPFRAME_MAXLEVEL == 1) then
        CleanUIData.XPFRAME_MAXLEVEL = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide players at max level", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.XPFRAME_MAXLEVEL = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show players at max level", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleXpFrame_Unknown()
    if (CleanUIData.XPFRAME_UNKNOWN == 1) then
        CleanUIData.XPFRAME_UNKNOWN = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide players without information", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.XPFRAME_UNKNOWN = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show players without information", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleThreatFrame()
    if (CleanUIData.SHOW_THREATFRAME == 1) then
        CleanUIData.SHOW_THREATFRAME = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide threat frame", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.SHOW_THREATFRAME = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show threat frame", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectThreatFrame(self)

    if (CleanUIData.THREATFRAME_RAWPCT ~= self:GetValue()) then
        CleanUIData.THREATFRAME_RAWPCT = self:GetValue();
        
        if (CleanUIData.THREATFRAME_RAWPCT == 1) then        
            DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r threat type set to 130 %", 1.0, 1.0, 1.0, 1, 10);
        else
            DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r threat type set to 100 %", 1.0, 1.0, 1.0, 1, 10);
        end
        
        CleanUIConfig_ConfigChanged();
    end
end

function CleanUIConfig_SelectThreatAlpha(self)

    if (CleanUIData.THREATFRAME_ALPHA ~= self:GetValue()) then
        CleanUIData.THREATFRAME_ALPHA = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (_G["CleanUIThreatFrame"]) then
            _G["CleanUIThreatFrame"]:SetAlpha(CleanUIData.THREATFRAME_ALPHA);
        end
    end
end

function CleanUIConfig_ToggleCleanActionBars()
    if (CleanUIData.CHANGE_ACTIONBARS == 1) then
        CleanUIData.CHANGE_ACTIONBARS = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't change action bars", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CHANGE_ACTIONBARS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r change action bars", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_UpdateActionBars();
end

function CleanUIConfig_ToggleMacroNames()
    if (CleanUIData.ACTIONBARS_SHOWMACRONAMES == 1) then
        CleanUIData.ACTIONBARS_SHOWMACRONAMES = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide macro names", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.ACTIONBARS_SHOWMACRONAMES = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show macro names", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_UpdateActionBars();
end

function CleanUIConfig_TogglePlayerStatusBars()
    if (CleanUIData.ACTIONBARS_SHOWSTATUS == 1) then
        CleanUIData.ACTIONBARS_SHOWSTATUS = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide status bars", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.ACTIONBARS_SHOWSTATUS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show status bars", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_UpdateActionBars();
end

function CleanUIConfig_TogglePlayerStatusBarText()
    if (CleanUIData.ACTIONBARS_SHOWSTATUSTEXT == 1) then
        CleanUIData.ACTIONBARS_SHOWSTATUSTEXT = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide status bar text", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.ACTIONBARS_SHOWSTATUSTEXT = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show status bar text", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_UpdateActionBars();
end

function CleanUIConfig_TogglePlayerStatusBarPosition()
    if (CleanUIData.ACTIONBARS_STATUSPOSITION == 1) then
        CleanUIData.ACTIONBARS_STATUSPOSITION = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r switch status bar position", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.ACTIONBARS_STATUSPOSITION = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r switch status bar position", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_UpdateActionBars();
end

function CleanUIConfig_SelectPlayerStatusBarWidth(self)

    if (CleanUIData.ACTIONBARS_STATUSWIDTH ~= self:GetValue()) then
        CleanUIData.ACTIONBARS_STATUSWIDTH = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        CleanUI_UpdateActionBars();
    end
end

function CleanUIConfig_ToggleDeBuffsForActionButtons()
    if (CleanUIData.ACTIONBARS_DEBUFFS == 1) then
        CleanUIData.ACTIONBARS_DEBUFFS = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide buffs and debuffs for action buttons", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.ACTIONBARS_DEBUFFS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show buffs and debuffs for action buttons", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectDeBuffsColor()
	ColorPickerFrame.func = CleanUIConfig_SetDeBuffsColor;
	ColorPickerFrame:SetColorRGB(CleanUIData.ACTIONBARS_DEBUFFS_R, CleanUIData.ACTIONBARS_DEBUFFS_G, CleanUIData.ACTIONBARS_DEBUFFS_B);
	ShowUIPanel(ColorPickerFrame);
end

function CleanUIConfig_SetDeBuffsColor()
	local r,g,b = ColorPickerFrame:GetColorRGB();
	CleanUIData.ACTIONBARS_DEBUFFS_R = r;
	CleanUIData.ACTIONBARS_DEBUFFS_G = g;
	CleanUIData.ACTIONBARS_DEBUFFS_B = b;
	
	_G["CleanUIDeBuffsBarColorExample"]:SetStatusBarColor(CleanUIData.ACTIONBARS_DEBUFFS_R, CleanUIData.ACTIONBARS_DEBUFFS_G, CleanUIData.ACTIONBARS_DEBUFFS_B);
end

function CleanUIConfig_ToggleButtonFacadeForActionButtons()
    if (CleanUIData.BUTTONFACADE_ACTIONBUTTONS == 1) then
        CleanUIData.BUTTONFACADE_ACTIONBUTTONS = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't use ButtonFacade for action buttons", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.BUTTONFACADE_ACTIONBUTTONS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r use ButtonFacade for action buttons", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleButtonFacadeForBuffs()
    if (CleanUIData.BUTTONFACADE_BUFFS == 1) then
        CleanUIData.BUTTONFACADE_BUFFS = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't use ButtonFacade for buffs and debuffs", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.BUTTONFACADE_BUFFS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r use ButtonFacade for buffs and debuffs", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleBiggerDebuffs()
    if (CleanUIData.BIGGER_DEBUFFS == 1) then
        CleanUIData.BIGGER_DEBUFFS = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't use bigger debuffs", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.BIGGER_DEBUFFS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r use bigger debuffs", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeBags()
    if (CleanUIData.CHANGE_BAGS == 1) then
        CleanUIData.CHANGE_BAGS = 0;
        
        DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't change bags", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CHANGE_BAGS = 1;
        
        DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r change bags", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleUseBigBag()
    if (CleanUIData.USE_BIGBAG == 1) then
        CleanUIData.USE_BIGBAG = 0;
        
        DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't use big bag", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.USE_BIGBAG = 1;
        CleanUIData.BAGS_MOVEBAGBUTTONS = 1;
        
        DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r use big bag", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleColorizeItems()
    if (CleanUIData.BAGS_COLORIZE_ITEMS == 1) then
        CleanUIData.BAGS_COLORIZE_ITEMS = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't colorize items", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.BAGS_COLORIZE_ITEMS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r colorize items", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowWhiteAsGray()
    if (CleanUIData.BAGS_SHOW_WHITE_AS_GRAY == 1) then
        CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't show white as gray", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show white as gray", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleMoveBagButtons()
    if (CleanUIData.BAGS_MOVEBAGBUTTONS == 1) then
        CleanUIData.BAGS_MOVEBAGBUTTONS = 0;
        CleanUIData.BAGS_SHOWBACKBACKBUTTON = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't move bag buttons", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.BAGS_MOVEBAGBUTTONS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r move bag buttons", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowBackpackButton()
    if (CleanUIData.BAGS_SHOWBACKBACKBUTTON == 1) then
        CleanUIData.BAGS_SHOWBACKBACKBUTTON = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide backpack button", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.BAGS_SHOWBACKBACKBUTTON = 1;
        CleanUIData.MOVE_SECOND_ACTIONBAR = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show backpack button", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleBagsAutoRepair()
    if (CleanUIData.BAGS_AUTOREPAIR == 1) then
        CleanUIData.BAGS_AUTOREPAIR = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r auto repair off", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.BAGS_AUTOREPAIR = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r auto repair on", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleBagsAutoSellGray()
    if (CleanUIData.BAGS_AUTOSELLGRAY == 1) then
        CleanUIData.BAGS_AUTOSELLGRAY = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r auto sell off", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.BAGS_AUTOSELLGRAY = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r auto sell on", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeCastingBars()
    if (CleanUIData.CHANGE_CASTINGBARS == 1) then
        CleanUIData.CHANGE_CASTINGBARS = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't change casting bars", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CHANGE_CASTINGBARS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r change casting bars", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCastingBarsShowPetBar()
    if (CleanUIData.CASTINGBARS_SHOWPETBAR == 1) then
        CleanUIData.CASTINGBARS_SHOWPETBAR = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide pet casting bar", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CASTINGBARS_SHOWPETBAR = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show pet casting bar", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectCastingBarAlpha(self)

    if (CleanUIData.CASTINGBARS_ALPHA ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_ALPHA = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CastingBarFrame and CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectDeBuffsBarHeight(self)

    if (CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT ~= self:GetValue()) then
        CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
    end
end

function CleanUIConfig_SelectCastingBarWidth(self)

    if (CleanUIData.CASTINGBARS_WIDTH ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_WIDTH = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CastingBarFrame and CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectPlayerCastingBarHeight(self)

    if (CleanUIData.CASTINGBARS_PLAYERHEIGHT ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_PLAYERHEIGHT = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectPlayerCastingBarImageSize(self)

    if (CleanUIData.CASTINGBARS_IMAGESIZE ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_IMAGESIZE = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectPetCastingBarHeight(self)

    if (CleanUIData.CASTINGBARS_PETHEIGHT ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_PETHEIGHT = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectGlobalCooldownHeight(self)

    if (CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
        
        if (CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_ToggleCleanMinimap()
    if (CleanUIData.CHANGE_MINIMAP == 1) then
        CleanUIData.CHANGE_MINIMAP = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't change minimap", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CHANGE_MINIMAP = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r change minimap", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCleanUnitFrames()
    if (CleanUIData.CHANGE_UNITFRAMES == 1) then
        CleanUIData.CHANGE_UNITFRAMES = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't change unit frames", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CHANGE_UNITFRAMES = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r change unit frames", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCleanBossFrames()
    if (CleanUIData.CHANGE_BOSSFRAMES == 1) then
        CleanUIData.CHANGE_BOSSFRAMES = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't change boss frames", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CHANGE_BOSSFRAMES = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r change boss frames", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowDpsFrame()
    if (CleanUIData.SHOW_DPS == 1) then
        CleanUIData.SHOW_DPS = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't show dps", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.SHOW_DPS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show dps", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_ToggleDpsFrameVisibility();    
end

function CleanUIConfig_ToggleShowDpsFrameInfo()
    if (CleanUIData.SHOW_DPSINFO == 1) then
        CleanUIData.SHOW_DPSINFO = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show dps text only when mouse over", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.SHOW_DPSINFO = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r always show dps info text", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
    CleanUI_ToggleDpsFrameVisibility();    
end

function CleanUIConfig_ToggleMergePetDpsData()
    if (CleanUIData.MERGEPETDPSDATA == 1) then
        CleanUIData.MERGEPETDPSDATA = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't merge pet data", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.MERGEPETDPSDATA = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r merge pet data", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged(); 
end

function CleanUIConfig_ToggleCastingBarsShowGlobalCooldown(self)
    if (CleanUIData.CASTINGBARS_GLOBALCOOLDOWN == 1) then
        CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide global cooldown", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show global cooldown", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCastingBarsShowLatency(self)
    if (CleanUIData.CASTINGBARS_LATENCY == 1) then
        CleanUIData.CASTINGBARS_LATENCY = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide latency", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CASTINGBARS_LATENCY = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show latency", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CUIConfig_PortraitStyleDropDown_Initialize(self)
	for i = 1, #PORTRAIT_TYPE do
        local info = UIDropDownMenu_CreateInfo();
        info.text = PORTRAIT_TYPE[i];
        info.value = i;
        info.func = function()
                CUIConfig_SelectPortraitStyle(i);
            end
        UIDropDownMenu_AddButton(info);
	end
end

function CUIConfig_SelectPortraitStyle(index)
    CleanUIData.PORTRAIT_STYLE = index;
	UIDropDownMenu_SetSelectedValue(CUIConfig_PortraitStyleDropDown, index);
    
    CleanUIConfig_ConfigChanged();
    CleanUI_UpdateAllPortraits();
end

function CUIConfig_UnitFramePositionsDropDown_Initialize(self)
	for i = 1, #UNITFRAME_POSITION_TYPE do
        local info = UIDropDownMenu_CreateInfo();
        info.text = UNITFRAME_POSITION_TYPE[i];
        info.value = i;
        info.func = function()
                CUIConfig_SelectUnitFramePosition(i);
            end
        UIDropDownMenu_AddButton(info);
	end
end

function CUIConfig_SelectUnitFramePosition(index)
    CleanUIData.UNITFRAME_POSITIONS = index;
	UIDropDownMenu_SetSelectedValue(CUIConfig_UnitFramePositionsDropDown, index);
	
	if (index == 1) then
	    CleanUIConfig_LoadDefaultUnitFramePositions();
	elseif (index == 2) then
	    CleanUIConfig_LoadBattleUnitFramePositions();
	else
	    CleanUIConfig_LoadDefaultUnitFramePositions();
	end
end

function CleanUIConfig_ToggleMapLevel()
    if (CleanUIData.MAP_SHOWQUESTLEVEL == 1) then
        CleanUIData.MAP_SHOWQUESTLEVEL = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide level info", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.MAP_SHOWQUESTLEVEL = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show level info", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleMapRoutes()
    if (CleanUIData.MAP_SHOWSHIPROUTES == 1) then
        CleanUIData.MAP_SHOWSHIPROUTES = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide routes", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.MAP_SHOWSHIPROUTES = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show routes", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeChat()
    if (CleanUIData.CHANGE_CHAT == 1) then
        CleanUIData.CHANGE_CHAT = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't change chat", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CHANGE_CHAT = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r change chat", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleDisableAltArrowKeyMode()
    if (CleanUIData.DISABLE_ALTARROWKEYMODE == 1) then
        CleanUIData.DISABLE_ALTARROWKEYMODE = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't disable alt arrow key mode", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.DISABLE_ALTARROWKEYMODE = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r disable alt arrow key mode", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowChatActionBar()
    if (CleanUIData.SHOW_CHAT_ACTIONBAR == 1) then
        CleanUIData.SHOW_CHAT_ACTIONBAR = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide chat action bar", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.SHOW_CHAT_ACTIONBAR = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show chat action bar", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowChatEmoticons()
    if (CleanUIData.SHOW_CHAT_EMOTICONS == 1) then
        CleanUIData.SHOW_CHAT_EMOTICONS = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't add emoticons to the chat menu", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.SHOW_CHAT_EMOTICONS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r add emoticons to the chat menu", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeRaid()
    if (CleanUIData.CHANGE_RAID == 1) then
        CleanUIData.CHANGE_RAID = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't change raid frames", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CHANGE_RAID = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r change raid frames", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleHideTooltipsInCombat()
    if (CleanUIData.TOOLTIPS_HIDEINCOMBAT == 1) then
        CleanUIData.TOOLTIPS_HIDEINCOMBAT = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't hide tooltips in combat", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.TOOLTIPS_HIDEINCOMBAT = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r hide tooltips in combat", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeNameplates()
    if (CleanUIData.CHANGE_NAMEPLATES == 1) then
        CleanUIData.CHANGE_NAMEPLATES = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't change nameplates", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.CHANGE_NAMEPLATES = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r change nameplates", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleNameplatesPercent()
    if (CleanUIData.NAMEPLATES_PERCENT == 1) then
        CleanUIData.NAMEPLATES_PERCENT = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't show percent values", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.NAMEPLATES_PERCENT = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show percent values", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleNameplatesHighlightTarget()
    if (CleanUIData.NAMEPLATES_HIGHLIGHTTARGET == 1) then
        CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't highlight target", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r highlight target", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleNameplatesComboPoints()
    if (CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS == 1) then
        CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't show combo points", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show combo points", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowDataBroker()
    if (CleanUIData.SHOW_DATABROKER == 1) then
        CleanUIData.SHOW_DATABROKER = 0;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r don't show databroker", 1.0, 1.0, 1.0, 1, 10);
    else
        CleanUIData.SHOW_DATABROKER = 1;
        
 	    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r show databroker", 1.0, 1.0, 1.0, 1, 10);
    end
    
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectDataBrokerCountRows(self)

    if (CleanUIData.DATABROKER_COUNTROWS ~= self:GetValue()) then
        CleanUIData.DATABROKER_COUNTROWS = self:GetValue();
        
        CleanUIConfig_ConfigChanged();
    end
end