ZoneNames = {};

function LoadZones(...)
   for i=1, arg.n, 1 do
      ZoneNames[i] = arg[i];
   end
end

CUI_MAP_INFO = {};

CUI_MAP_INFO[0] = {name="elwynn", min=1, max=10, faction="a", left=45, top=75};
CUI_MAP_INFO[1] = {name="westfall", min=10, max=15, faction="a", left=41, top=82};
CUI_MAP_INFO[2] = {name="rotkamm", min=15, max=20, faction="", left=52, top=76};
CUI_MAP_INFO[3] = {name="daemm", min=20, max=25, faction="", left=46, top=81};
CUI_MAP_INFO[4] = {name="schling1", min=25, max=30, faction="", left=47, top=86};
CUI_MAP_INFO[5] = {name="schling2", min=30, max=35, faction="", left=44, top=92};
CUI_MAP_INFO[6] = {name="suempfe", min=52, max=54, faction="", left=53, top=80};
CUI_MAP_INFO[7] = {name="verwuest", min=54, max=58, faction="", left=52, top=85};
CUI_MAP_INFO[8] = {name="brenn", min=50, max=52, faction="", left=51, top=71};
CUI_MAP_INFO[9] = {name="seng", min=48, max=50, faction="", left=47, top=66};
CUI_MAP_INFO[10] = {name="oedl", min=45, max=48, faction="", left=53, top=67};
CUI_MAP_INFO[11] = {name="vashi", min=80, max=82, faction="", left=31, top=63};
CUI_MAP_INFO[12] = {name="dun", min=1, max=10, faction="a", left=44, top=61};
CUI_MAP_INFO[13] = {name="loch", min=10, max=20, faction="a", left=53, top=61};
CUI_MAP_INFO[14] = {name="sumpfl", min=20, max=25, faction="", left=49, top=53};
CUI_MAP_INFO[15] = {name="schatten", min=84, max=85, faction="", left=55, top=55};
CUI_MAP_INFO[16] = {name="arathi", min=25, max=30, faction="", left=51, top=46};
CUI_MAP_INFO[17] = {name="hinter", min=30, max=35, faction="", left=52, top=40};
CUI_MAP_INFO[18] = {name="vorgeb", min=20, max=25, faction="", left=46, top=43};
CUI_MAP_INFO[19] = {name="giln", min=1, max=12, faction="a", left=40, top=47};
CUI_MAP_INFO[20] = {name="silber", min=10, max=20, faction="h", left=41, top=41};
CUI_MAP_INFO[21] = {name="tiris", min=1, max=10, faction="h", left=44, top=33};
CUI_MAP_INFO[22] = {name="westl", min=35, max=40, faction="", left=49, top=33};
CUI_MAP_INFO[23] = {name="oestl", min=40, max=45, faction="", left=54, top=32};
CUI_MAP_INFO[24] = {name="immer", min=1, max=10, faction="h", left=55, top=17};
CUI_MAP_INFO[25] = {name="geister", min=10, max=20, faction="h", left=55, top=24};
CUI_MAP_INFO[26] = {name="quelda", min=70, faction="pvp", left=56, top=5};
CUI_MAP_INFO[27] = {name="tolbarad", min=85, faction="pvp", left=35, top=49};
CUI_MAP_INFO[28] = {name="maelst1", info="Maelstrom", min=82, max=83, faction="", left=6, top=41};
CUI_MAP_INFO[29] = {name="maelst2", info="Maelstrom", min=82, max=83, faction="", left=86, top=41};
CUI_MAP_INFO[30] = {name="uldum", min=83, max=84, faction="", left=47, top=91};
CUI_MAP_INFO[31] = {name="tanaris", min=45, max=50, faction="", left=55, top=86};
CUI_MAP_INFO[32] = {name="ungoro", min=50, max=55, faction="", left=50, top=81};
CUI_MAP_INFO[33] = {name="silithus", min=55, max=60, faction="", left=42, top=82};
CUI_MAP_INFO[34] = {name="feralas", min=35, max=40, faction="", left=43, top=70};
CUI_MAP_INFO[35] = {name="tausend", min=40, max=45, faction="", left=51, top=74};
CUI_MAP_INFO[36] = {name="morast", min=35, max=40, faction="", left=56, top=70};
CUI_MAP_INFO[37] = {name="suedlbrach", min=30, max=35, faction="", left=52, top=60};
CUI_MAP_INFO[38] = {name="mulgore", min=1, max=10, faction="h", left=47, top=62};
CUI_MAP_INFO[39] = {name="desolace", min=30, max=35, faction="", left=41, top=58};
CUI_MAP_INFO[40] = {name="steinkral", min=25, max=30, faction="", left=43, top=47};
CUI_MAP_INFO[41] = {name="noerdlbrach", min=10, max=20, faction="h", left=52, top=50};
CUI_MAP_INFO[42] = {name="durotar", min=1, max=10, faction="h", left=58, top=51};
CUI_MAP_INFO[43] = {name="azshara", min=10, max=20, faction="h", left=60, top=40};
CUI_MAP_INFO[44] = {name="eschental", min=20, max=25, faction="", left=50, top=42};
CUI_MAP_INFO[45] = {name="teufelswald", min=45, max=50, faction="", left=49, top=27};
CUI_MAP_INFO[46] = {name="hyal", min=80, max=82, faction="", left=53, top=33};
CUI_MAP_INFO[47] = {name="winterq", min=50, max=55, faction="", left=57, top=25};
CUI_MAP_INFO[48] = {name="dunkelk", min=10, max=20, faction="a", left=47, top=23};
CUI_MAP_INFO[49] = {name="teldra", min=1, max=10, faction="a", left=42, top=11};
CUI_MAP_INFO[50] = {name="blutmyt", min=10, max=20, faction="a", left=29, top=19};
CUI_MAP_INFO[51] = {name="azurm", min=1, max=10, faction="a", left=32, top=28};
CUI_MAP_INFO[52] = {name="hoellenf", min=58, max=63, faction="", left=54, top=52};
CUI_MAP_INFO[53] = {name="zangar", min=60, max=64, faction="", left=33, top=48};
CUI_MAP_INFO[54] = {name="terokkar", min=62, max=65, faction="", left=46, top=75};
CUI_MAP_INFO[55] = {name="nagrand", min=64, max=67, faction="", left=30, top=65};
CUI_MAP_INFO[56] = {name="schergrat", min=65, max=68, faction="", left=38, top=30};
CUI_MAP_INFO[57] = {name="nethersturm", min=67, max=70, faction="", left=57, top=19};
CUI_MAP_INFO[58] = {name="schattenmond", min=67, max=70, faction="", left=64, top=80};
CUI_MAP_INFO[59] = {name="heulenderf", min=68, max=72, faction="", left=77, top=75};
CUI_MAP_INFO[60] = {name="borean", min=68, max=72, faction="", left=23, top=61};
CUI_MAP_INFO[61] = {name="drachenoede", min=71, max=74, faction="", left=48, top=55};
CUI_MAP_INFO[62] = {name="grizzly", min=73, max=75, faction="", left=73, top=54};
CUI_MAP_INFO[63] = {name="zuldrak", min=74, max=77, faction="", left=67, top=42};
CUI_MAP_INFO[64] = {name="sholazar", min=76, max=78, faction="", left=23, top=41};
CUI_MAP_INFO[65] = {name="sturmgipfel", min=77, max=80, faction="", left=59, top=27};
CUI_MAP_INFO[66] = {name="eiskrone", min=77, max=80, faction="", left=38, top=28};
CUI_MAP_INFO[67] = {name="kristalls", min=77, max=80, faction="", left=50, top=41};
CUI_MAP_INFO[68] = {name="tausendw", min=77, max=80, faction="pvp", left=35, top=48};
        
-- 13 = Kalimdor
-- 14 = Azeroth
-- 466 = Outlands
-- 485 = Northrend

CUI_MAP_RANGE = {};
CUI_MAP_RANGE[14] = {min = 0, max = 28};
CUI_MAP_RANGE[13] = {min = 29, max = 51};
CUI_MAP_RANGE[466] = {min = 52, max = 58};
CUI_MAP_RANGE[485] = {min= 59, max = 68};


local loaded = false;

function CleanUI_MapOnEvent(self, event, ...)
	if (event == "WORLD_MAP_UPDATE") then
	    local miniWorldMap = GetCVar("miniWorldMap"); 	
 	    CleanUI_UpdateMap(miniWorldMap);
    end
	if (event == "PLAYER_LEVEL_UP") then
		CleanUI_StartDelay(CUI_START_DELAY, CleanUI_CleanMap);
    end
end

function CleanUI_CleanMap()

    local infoframe = _G["CleanUIMapLevelFrame"];
    infoframe:ClearAllPoints(); 
    infoframe:SetAllPoints(WorldMapDetailFrame);
    
    local playerLevel = UnitLevel("player");
        
	for ii=0, #(CUI_MAP_INFO), 1 do	
	    local fontstring = _G["CUI_MI_"..CUI_MAP_INFO[ii].name];
	    
	    if (not fontstring) then
	        fontstring = infoframe:CreateFontString("CUI_MI_"..CUI_MAP_INFO[ii].name, "ARTWORK");
	    end
	    
        fontstring:SetFontObject("GameFontNormalSmall");
        
        local min = CUI_MAP_INFO[ii].min;
        local max = CUI_MAP_INFO[ii].max or min;
        local info = CUI_MAP_INFO[ii].info;
        
        local text = ""..min;
        
        if (min < max) then
            text = text.."-"..max;
        end
        
        if (info) then
            text = info.." "..text;
        end
        
        local color = "ffffff";
        
        if (CUI_MAP_INFO[ii].faction == "a") then
            color = "4444dd";
        elseif (CUI_MAP_INFO[ii].faction == "h") then
            color = "dd4444";
        elseif (CUI_MAP_INFO[ii].faction == "pvp") then
            color = "aa44aa";
        end
        
        text = "|cff"..color..text.."|r";
        
        -- font size and alpha
        if (playerLevel > max) then
            fontstring:SetFontObject("GameFontNormalSmall");
            fontstring:SetAlpha(0.5);
        elseif (playerLevel > min and playerLevel < max) then
            fontstring:SetFontObject("GameFontNormal");
            fontstring:SetAlpha(1.0);
        else
            fontstring:SetFontObject("GameFontNormalSmall");
            fontstring:SetAlpha(1.0);
        end  
        
        -- faction icon
        if (CUI_MAP_INFO[ii].faction == "a") then
            text = "|TInterface/WorldStateFrame/AllianceIcon:20|t"..text;
        elseif (CUI_MAP_INFO[ii].faction == "h") then
            text = "|TInterface/WorldStateFrame/HordeIcon:20|t"..text;
        elseif (CUI_MAP_INFO[ii].faction == "pvp") then
            text = "|TInterface/GossipFrame/BattleMasterGossipIcon:20|t"..text;
        end
        
        -- level icon
        if (playerLevel < min - 5) then
            text = "|TInterface/TargetingFrame/UI-TargetingFrame-Skull:20|t"..text;
        elseif (playerLevel > min - 1 and playerLevel < max + 1) then
            text = "|TInterface/OptionsFrame/UI-OptionsFrame-NewFeatureIcon:16|t"..text;
        end
        
        fontstring:SetText(text);
        
        local framewidth = infoframe:GetWidth();
        local frameheight = infoframe:GetHeight();
        
        local x = CUI_MAP_INFO[ii].left / 100 * framewidth;
        local y = CUI_MAP_INFO[ii].top / 100 * frameheight * -1;
        
        fontstring:ClearAllPoints(); 
        fontstring:SetPoint("CENTER", infoframe, "TOPLEFT", x, y);
    end
    
    -- Header
    if (not _G["CUI_MI_HEADER"]) then
        local header = infoframe:CreateFontString("CUI_MI_HEADER", "ARTWORK");
        header:SetFontObject("GameFontNormalSmall");
        header:SetText("|cffffffff"..BATTLEFIELD_LEVEL.."|r");
        header:ClearAllPoints(); 
        header:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -30);
    end
    
    -- Allianz
    if (not _G["CUI_MI_ALLIANCE"]) then
        local horde = infoframe:CreateFontString("CUI_MI_ALLIANCE", "ARTWORK");
        horde:SetFontObject("GameFontNormalSmall");
        horde:SetText("|TInterface/WorldStateFrame/AllianceIcon:20|t".."|cff4444dd"..FACTION_ALLIANCE.."|r");
        horde:ClearAllPoints(); 
        horde:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -50);
    end
    
    if (not _G["CUI_MI_HORDE"]) then
    -- Horde
        local horde = infoframe:CreateFontString("CUI_MI_HORDE", "ARTWORK");
        horde:SetFontObject("GameFontNormalSmall");
        horde:SetText("|TInterface/WorldStateFrame/HordeIcon:20|t".."|cffdd4444"..FACTION_HORDE.."|r");
        horde:ClearAllPoints(); 
        horde:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -66);
    end
    
    -- Passend
    if (not _G["CUI_MI_BEST"]) then
        local all = infoframe:CreateFontString("CUI_MI_BEST", "ARTWORK");
        all:SetFontObject("GameFontNormalSmall");
        all:SetText( "|TInterface/OptionsFrame/UI-OptionsFrame-NewFeatureIcon:16|t".."|cffffffff"..CURRENT_QUESTS.."|r");
        all:ClearAllPoints(); 
        all:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -82);
    end
    
    -- PvP
    if (not _G["CUI_MI_PVP"]) then
        local horde = infoframe:CreateFontString("CUI_MI_PVP", "ARTWORK");
        horde:SetFontObject("GameFontNormalSmall");
        horde:SetText("|TInterface/GossipFrame/BattleMasterGossipIcon:20|t".."|cffaa44aa"..PVP.."|r");
        horde:ClearAllPoints(); 
        horde:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -98);
    end
    
    -- PvP
    if (not _G["CUI_MI_DIFFICULT"]) then
        local horde = infoframe:CreateFontString("CUI_MI_DIFFICULT", "ARTWORK");
        horde:SetFontObject("GameFontNormalSmall");
        horde:SetText("|TInterface/TargetingFrame/UI-TargetingFrame-Skull:20|t".."|cffffffff"..TRACKER_SORT_DIFFICULTY_HIGH.."|r");
        horde:ClearAllPoints(); 
        horde:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -114);
    end
    
    -- map routes
    if (not _G["CUI_WorldMapFrameRoutes"]) then
    	local worldMapFrameRoutes = infoframe:CreateTexture("CUI_WorldMapFrameRoutes", "OVERLAY");
        worldMapFrameRoutes:ClearAllPoints();
        worldMapFrameRoutes:SetPoint("TOPLEFT", 0, 0);
        worldMapFrameRoutes:SetPoint("BOTTOMRIGHT", 0, 0);
	    worldMapFrameRoutes:SetTexture("Interface\\AddOns\\CleanUI\\skins\\maps\\boat-zeppelin-route-map");
    end
    
    if (not _G["CUI_MI_ALLIANCE_ROUTES"]) then
        local horde = infoframe:CreateFontString("CUI_MI_ALLIANCE_ROUTES", "ARTWORK");
        horde:SetFontObject("GameFontNormalSmall");
        horde:SetText("|cff4444dd"..FACTION_ALLIANCE.."|r");
        horde:ClearAllPoints(); 
        horde:SetPoint("BOTTOMLEFT", infoframe, "BOTTOMLEFT", 70, 75);
    end
    
    if (not _G["CUI_MI_HORDE_ROUTES"]) then
        local horde = infoframe:CreateFontString("CUI_MI_HORDE_ROUTES", "ARTWORK");
        horde:SetFontObject("GameFontNormalSmall");
        horde:SetText("|cffdd4444"..FACTION_HORDE.."|r");
        horde:ClearAllPoints(); 
        horde:SetPoint("BOTTOMLEFT", infoframe, "BOTTOMLEFT", 70, 51);
    end
    
    if (not _G["CUI_MI_OTHER_ROUTES"]) then
        local horde = infoframe:CreateFontString("CUI_MI_OTHER_ROUTES", "ARTWORK");
        horde:SetFontObject("GameFontNormalSmall");
        horde:SetText("|cff999955"..FACTION_OTHER.."|r");
        horde:ClearAllPoints(); 
        horde:SetPoint("BOTTOMLEFT", infoframe, "BOTTOMLEFT", 70, 27);
    end

    loaded = true;
end
    
function CleanUI_WorldMap_OnUpdate(self, elapsed)
    local player_x, player_y = CleanUI_GetPlayerMapPosition();
    local cursor_x, cursor_y = CleanUI_GetCursorPosition();
    
    local output = "";
    
    if (cursor_x == nil or cursor_y == nil) then
	    output = "Spieler: "..player_x.."|cffffffff/|r"..player_y;
    else
	    output = "Spieler: "..player_x.."|cffffffff/|r"..player_y.." -- Mauszeiger: "..cursor_x.."|cffffffff/|r"..cursor_y;
    end

   	CleanUIWorldMap:SetText(output);
end

function CleanUI_GetPlayerMapPosition()
	local x, y = GetPlayerMapPosition("player");
	
	x = x * 100;
	y = y * 100;
	
	return "|cffffffff"..string.format("%.1f", x).."|r", "|cffffffff"..string.format("%.1f", y).."|r";
end

function CleanUI_GetCursorPosition()
	
    local scale = WorldMapDetailFrame:GetEffectiveScale();
    local width = WorldMapDetailFrame:GetWidth();
    local height = WorldMapDetailFrame:GetHeight();
    local centerX, centerY = WorldMapDetailFrame:GetCenter();
    
    local x, y = GetCursorPosition();
    
    local adjustedX = (x / scale - (centerX - (width/2))) / width;
    local adjustedY = (centerY + (height/2) - y / scale) / height;	
	
	adjustedX = adjustedX * 100;
	adjustedY = adjustedY * 100;
	
	if (adjustedX > 100 or adjustedY > 100) then
	    return nil, nil;
	end

	return "|cffffffff"..string.format("%.1f", adjustedX).."|r", "|cffffffff"..string.format("%.1f", adjustedY).."|r";
end

function CleanUI_UpdateMap(miniWorldMap) 

    if (not loaded) then
        return;
    end
    
	BlackoutWorld:Hide();
	
    CleanUIMapLevelFrameToggleMapLevel:SetChecked(CleanUIData.MAP_SHOWQUESTLEVEL);
    CleanUIMapLevelFrameToggleMapRoutes:SetChecked(CleanUIData.MAP_SHOWSHIPROUTES);

    local showLevel = false;
    local showRoutes = false;
    
    local min = -1;
    local max = -1;
    
    if (miniWorldMap == "0") then
        -- full screen
        
        CleanUIWorldMap:ClearAllPoints();
        CleanUIWorldMap:SetPoint("BOTTOM", WorldMapFrame, "BOTTOM", 0, 10);
    
        local areaid = GetCurrentMapAreaID();
		local continentID = GetCurrentMapContinent();
        
        CleanUIMapLevelFrameToggleMapLevel:Hide();
        CleanUIMapLevelFrameToggleMapRoutes:Hide();
        
        if (areaid == 13 or areaid == 14 or areaid == 466 or areaid == 485) then
            min = CUI_MAP_RANGE[areaid].min;
            max = CUI_MAP_RANGE[areaid].max;
            
            CleanUIMapLevelFrameToggleMapLevel:Show();
            
            if (CleanUIData.MAP_SHOWQUESTLEVEL == 1) then
                showLevel = true;
            end
        elseif (areaid == -1 and continentID == 0) then
	        CleanUIMapLevelFrameToggleMapRoutes:Show();
	
            if (CleanUIData.MAP_SHOWSHIPROUTES == 1) then
                showRoutes = true;
            end
        end
    elseif (miniWorldMap == "1") then
        -- window
        
        CleanUIWorldMap:ClearAllPoints();
        CleanUIWorldMap:SetPoint("BOTTOMLEFT", WorldMapFrame, "BOTTOMLEFT", 10, 10);
    end
    
    -- Level-Informationen
    if (showLevel) then
        CUI_MI_HEADER:Show();
        CUI_MI_ALLIANCE:Show();
        CUI_MI_HORDE:Show();
        CUI_MI_BEST:Show();
        CUI_MI_PVP:Show();
        CUI_MI_DIFFICULT:Show();
    else
        CUI_MI_HEADER:Hide();
        CUI_MI_ALLIANCE:Hide();
        CUI_MI_HORDE:Hide();
        CUI_MI_BEST:Hide();
        CUI_MI_PVP:Hide();
        CUI_MI_DIFFICULT:Hide();
    end

	for ii=0, #(CUI_MAP_INFO), 1 do
        _G["CUI_MI_"..CUI_MAP_INFO[ii].name]:Hide();
            
        if (showLevel and ii >= min and ii<= max) then
            _G["CUI_MI_"..CUI_MAP_INFO[ii].name]:Show();  
        end
    end
    
    -- Schiff-/Zeppelinrouten
    if (showRoutes) then
        _G["CUI_WorldMapFrameRoutes"]:Show();
        CUI_MI_ALLIANCE_ROUTES:Show();
        CUI_MI_HORDE_ROUTES:Show();
        CUI_MI_OTHER_ROUTES:Show();
    else
        _G["CUI_WorldMapFrameRoutes"]:Hide();
        CUI_MI_ALLIANCE_ROUTES:Hide();
        CUI_MI_HORDE_ROUTES:Hide();
        CUI_MI_OTHER_ROUTES:Hide();
    end
end

function CleanUI_ToggleMapLevel()
    if (CleanUIData.MAP_SHOWQUESTLEVEL == 1) then
        CleanUIData.MAP_SHOWQUESTLEVEL = 0;
    else
        CleanUIData.MAP_SHOWQUESTLEVEL = 1;
    end
    
    local miniWorldMap = GetCVar("miniWorldMap"); 	
 	CleanUI_UpdateMap(miniWorldMap);
end

function CleanUI_ToggleMapRoutes()
    CleanUIConfig_ToggleMapRoutes();
    
    local miniWorldMap = GetCVar("miniWorldMap"); 	
 	CleanUI_UpdateMap(miniWorldMap);
end